#pragma once

#include <RobotAPI/interface/armem/commit.h>
#include <RobotAPI/interface/armem/memory.h>

#include "ice_conversions_templates.h"

#include "Commit.h"
#include "Memory.h"


namespace IceUtil
{
    // Define in original namespace to allow ADL.
    inline void toIce(long& ice, const Time& time)
    {
        ice = time.toMicroSeconds();
    }
    inline void fromIce(const long& ice, Time& time)
    {
        time = Time::microSeconds(ice);
    }
}


namespace armarx::armem
{

    // void fromIce(long ice, Time& time);
    // void toIce(long& ice, const Time& time);

    void fromIce(const data::MemoryID& ice, MemoryID& id);
    void toIce(data::MemoryID& ice, const MemoryID& id);


    void fromIce(const data::Commit& ice, Commit& commit);
    void toIce(data::Commit& ice, const Commit& commit);

    void fromIce(const data::CommitResult& ice, CommitResult& result);
    void toIce(data::CommitResult& ice, const CommitResult& result);


    void fromIce(const data::EntityUpdate& ice, EntityUpdate& update);
    void toIce(data::EntityUpdate& ice, const EntityUpdate& update);

    void fromIce(const data::EntityUpdateResult& ice, EntityUpdateResult& result);
    void toIce(data::EntityUpdateResult& ice, const EntityUpdateResult& result);


    // Server-side conversion with specified arrival time.
    void fromIce(const data::Commit& ice, Commit& commit, Time timeArrived);
    void fromIce(const data::EntityUpdate& ice, EntityUpdate& update, Time timeArrived);



    void toIce(data::EntityInstanceMetadata& ice, const EntityInstanceMetadata& metadata);
    void fromIce(const data::EntityInstanceMetadata& ice, EntityInstanceMetadata& metadata);

    void toIce(data::EntityInstance& ice, const EntityInstance& data);
    void fromIce(const data::EntityInstance& ice, EntityInstance& data);


    void toIce(data::EntitySnapshot& ice, const EntitySnapshot& snapshot);
    void fromIce(const data::EntitySnapshot& ice, EntitySnapshot& snapshot);

    void toIce(data::Entity& ice, const Entity& entity);
    void fromIce(const data::Entity& ice, Entity& entity);


    void toIce(data::ProviderSegment& ice, const ProviderSegment& providerSegment);
    void fromIce(const data::ProviderSegment& ice, ProviderSegment& providerSegment);

    void toIce(data::CoreSegment& ice, const CoreSegment& coreSegment);
    void fromIce(const data::CoreSegment& ice, CoreSegment& coreSegment);

    void toIce(data::Memory& ice, const Memory& memory);
    void fromIce(const data::Memory& ice, Memory& memory);


    namespace detail
    {
        void toIceItem(data::detail::MemoryItem& ice, const MemoryItem& item);
        void fromIceItem(const data::detail::MemoryItem& ice, MemoryItem& item);
    }

}

