#pragma once

#include <RobotAPI/interface/armem/query.h>

#include <RobotAPI/libraries/armem/core/Memory.h>

#include "BaseQueryProcessor.h"
#include "ProviderSegmentQueryProcessor.h"



namespace armarx::armem::query_proc
{

    /**
     * @brief Handles memory queries.
     */
    class CoreSegmentQueryProcessor : public BaseQueryProcessor<CoreSegment, armem::query::data::CoreSegmentQuery>
    {
    public:

        CoreSegmentQueryProcessor(DataMode dataMode = DataMode::WithData) :
            BaseQueryProcessor(dataMode), providerSegmentProcessor(dataMode)
        {}


        using BaseQueryProcessor::process;

        void process(CoreSegment& result, const armem::query::data::CoreSegmentQuery& query, const CoreSegment& coreSegment) const;

        void process(CoreSegment& result, const armem::query::data::core::All& query, const CoreSegment& coreSegment) const;
        void process(CoreSegment& result, const armem::query::data::core::Single& query, const CoreSegment& coreSegment) const;
        void process(CoreSegment& result, const armem::query::data::core::Regex& query, const CoreSegment& coreSegment) const;


        data::CoreSegment processToIce(const armem::query::data::CoreSegmentQuery& query, const CoreSegment& coreSegment) const;


    private:

        ProviderSegmentQueryProcessor providerSegmentProcessor;

    };

}
