#include "GroupBox.h"

#include <QCheckBox>
#include <QGuiApplication>
#include <QHBoxLayout>
#include <QScreen>
#include <QSplitter>
#include <QVBoxLayout>


namespace armarx::armem::gui::memory
{

    GroupBox::GroupBox()
    {
        QVBoxLayout* layout = new QVBoxLayout();
        this->setLayout(layout);

        QSplitter* splitter = new QSplitter(Qt::Orientation::Vertical);
        layout->addWidget(splitter);

        this->setTitle("Memory");
        int margin = 3;
        this->layout()->setContentsMargins(margin, margin, margin, margin);


        _tree = new armem::gui::MemoryTreeWidget();

        {
            _queryWidget = new armem::gui::QueryWidget();
            _queryWidget->setSizePolicy(QSizePolicy::Policy::Expanding, QSizePolicy::Policy::Maximum);

            _queryGroup = new QGroupBox("Queries");
            _queryGroup->setLayout(new QVBoxLayout());

            margin = 0;
            _queryGroup->setContentsMargins(margin, margin, margin, margin);
            _queryGroup->setSizePolicy(QSizePolicy::Policy::Expanding, QSizePolicy::Policy::Maximum);

            _queryGroup->layout()->addWidget(_queryWidget);
        }

        splitter->addWidget(_tree);
        splitter->addWidget(_queryGroup);
        // Prevent QueryGroup from growing.
        const int largeHeight = QGuiApplication::primaryScreen()->size().height();
        splitter->setSizes({largeHeight, 1});
    }

    QueryWidget* GroupBox::queryWidget() const
    {
        return _queryWidget;
    }

    QGroupBox* GroupBox::queryGroup() const
    {
        return _queryGroup;
    }

    MemoryTreeWidget* GroupBox::tree() const
    {
        return _tree;
    }

}
